using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Design;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinMaskedEdit;
using Infragistics.Win.UltraWinEditors;

namespace TraxView.AgTrax.Shared.BaseClasses
{
    [Designer(typeof(CurrencyEditorBaseDesigner))]
    public partial class CurrencyEditorBase : UserControl, IEditType
    {
        #region .   Variables   .

        #region .   BackColor   .
        [Description("The primary color used to fill the background."), Category("Appearance")]
        public Color BackColorCurrencyEditor
        {
            get { return this.ultraCurrencyEditor1.Appearance.BackColor; }
            set { this.ultraCurrencyEditor1.Appearance.BackColor = value; }
        }
        #endregion

        #region .   BackColor Disabled   .
        [Description("The primary color used to fill the background of disabled elements."), Category("Appearance")]
        public Color BackColorDisabledCurrencyEditor
        {
            get { return this.ultraCurrencyEditor1.Appearance.BackColorDisabled; }
            set { this.ultraCurrencyEditor1.Appearance.BackColorDisabled = value; }
        }
        #endregion

        #region .   Border Style   .
        [Description("Gets/Sets the border style used by the control."), Category("Appearance")]
        public UIElementBorderStyle BorderStyleCurrencyEditor
        {
            get { return this.ultraCurrencyEditor1.BorderStyle; }
            set { this.ultraCurrencyEditor1.BorderStyle = value; }
        }
        #endregion

        #region .   Use OS Themes   .
        [Description("Indicates whether the elements of a control may be rendered using the operating system theme rendering."), Category("Appearance")]
        public DefaultableBoolean UseOsThemes
        {
            get { return this.ultraCurrencyEditor1.UseOsThemes; }
            set { this.ultraCurrencyEditor1.UseOsThemes = value; }
        }
        #endregion

        #region .   Spin Button Display Style   .
        [Description("Gets/sets the display style for the controls spin buttons."), Category("Appearance")]
        public ButtonDisplayStyle SpinButtonDisplayStyle
        {
            get { return this.ultraCurrencyEditor1.SpinButtonDisplayStyle; }
            set { this.ultraCurrencyEditor1.SpinButtonDisplayStyle = value; }
        }
        #endregion

        #region .   Spin Button Alignment   .
        [Description("Gets/sets the alignment for the controls spin buttons."), Category("Appearance")]
        public ButtonAlignment SpinButtonAlignment
        {
            get { return this.ultraCurrencyEditor1.SpinButtonAlignment; }
            set { this.ultraCurrencyEditor1.SpinButtonAlignment = value; }
        }
        #endregion

        #region .   Mask Input   .
        [Description("Gets/sets the input mask used by the control."), Category("Behavior")]
        [Editor(typeof(MaskUITypeEditor), typeof(UITypeEditor))]
        [TypeConverter(typeof(MaskTypeConverter))]
        public virtual string MaskInput
        {
            get { return this.ultraCurrencyEditor1.MaskInput; }
            set { this.ultraCurrencyEditor1.MaskInput = value; }
        }
        #endregion

        #region .   Spin Wrap   .
        [Description("Gets/sets a value indicating whether the controls spin buttons should wrap its value."), Category("Behavior")]
        public bool SpinWrap
        {
            get { return this.ultraCurrencyEditor1.SpinWrap; }
            set { this.ultraCurrencyEditor1.SpinWrap = value; }
        }
        #endregion

        #region .   Format String   .
        [Description("Gets/sets the format string used by the control."), Category("Behavior")]
        public string FormatString
        {
            get { return this.ultraCurrencyEditor1.FormatString; }
            set { this.ultraCurrencyEditor1.FormatString = value; }
        }
        #endregion

        #region .   Min Value   .
        [Description("Gets/sets the control's minimum allowable value."), Category("Behavior")]
        public decimal MinValue
        {
            get { return this.ultraCurrencyEditor1.MinValue; }
            set { this.ultraCurrencyEditor1.MinValue = value; }
        }
        #endregion

        #region .   Max Value   .
        [Description("Gets/sets the control's maximum allowable value."), Category("Behavior")]
        public decimal MaxValue
        {
            get { return this.ultraCurrencyEditor1.MaxValue; }
            set { this.ultraCurrencyEditor1.MaxValue = value; }
        }
        #endregion

        #region .   Mask Clip Mode   .
        [Description("Gets/sets the mask that is applied to the controls text when it is copied to the clipboard."), Category("Behavior")]
        public MaskMode MaskClipMode
        {
            get { return this.ultraCurrencyEditor1.MaskClipMode; }
            set { this.ultraCurrencyEditor1.MaskClipMode = value; }
        }
        #endregion

        #region .   Mask Display Mode   .
        [Description("Gets/sets the mask that is applied to the text displayed by the control."), Category("Behavior")]
        public MaskMode MaskDisplayMode
        {
            get { return this.ultraCurrencyEditor1.MaskDisplayMode; }
            set { this.ultraCurrencyEditor1.MaskDisplayMode = value; }
        }
        #endregion

        #region .   Prompt Character   .
        [Description("Character used for prompts."), Category("Misc")]
        public char PromptChar
        {
            get { return this.ultraCurrencyEditor1.PromptChar; }
            set { this.ultraCurrencyEditor1.PromptChar = value; }
        }
        #endregion

        #region .   Tab Navigation   .
        [Description(""), Category("Misc")]
        public MaskedEditTabNavigation TabNavigation
        {
            get { return this.ultraCurrencyEditor1.TabNavigation; }
            set { this.ultraCurrencyEditor1.TabNavigation = value; }
        }
        #endregion

        #region .   Enabled   .
        [Description("Indicates whether the control is enabled."), Category("Behavior")]
        public bool EnabledCurrencyEditor
        {
            get { return this.ultraCurrencyEditor1.Enabled; }
            set { this.ultraCurrencyEditor1.Enabled = value; }
        }
        #endregion

        #region .   Tab Index   .
        [Description("Determines the index in the TAB order that this control will occupy."), Category("Behavior")]
        public int TabIndexCurrencyEditor
        {
            get { return this.ultraCurrencyEditor1.TabIndex; }
            set { this.ultraCurrencyEditor1.TabIndex = value; }
        }
        #endregion

        #region .   Tab Stop   .
        [Description("Indicates wheter the user can use the TAB key to give focus to the control."), Category("Behavior")]
        public bool TabStopCurrencyEditor
        {
            get { return this.ultraCurrencyEditor1.TabStop; }
            set { this.ultraCurrencyEditor1.TabStop = value; }
        }
        #endregion

        #endregion

        #region .   Currency Editor Base   .
        public CurrencyEditorBase()
        {
            InitializeComponent();
        }
        #endregion

        #region .   Events   .

        #region .   Resize   .
        private void CurrencyEditorBase_Resize(object sender, EventArgs e)
        {
            this.ultraCurrencyEditor1.Size = ((Control)sender).Size;
        }
        #endregion

        #region .   Enter   .
        private void CurrencyEditorBase_Enter(object sender, EventArgs e)
        {
            this.ultraCurrencyEditor1.SelectAll();
        }
        #endregion

        #region .   Ultra Currency Editor Events   .

        #region .   Key Down   .
        private void ultraCurrencyEditor1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.A && e.Modifiers == Keys.Control && this.ultraCurrencyEditor1.Text != "")
            {
                e.Handled = true;
                this.ultraCurrencyEditor1.SelectAll();
            }
        }

        #endregion

        #region .   Enter   .
        private void ultraCurrencyEditor1_Enter(object sender, EventArgs e)
        {
            this.ultraCurrencyEditor1.SelectAll();
        }
        #endregion

        #endregion

        #endregion

        #region .   Prompt Control Members   .

        #region .   Get Values   .
        public string[] GetValues()
        {
            return (new string[] { this.ultraCurrencyEditor1.Value.ToString() });
        }
        #endregion

        #region .   Get Value   .
        public string GetValue()
        {
            return (this.ultraCurrencyEditor1.Value.ToString());
        }
        #endregion

        #region .   Get Grid   .
        public ArrayList GetGrid()
        {
            return null;
        }
        #endregion .   Get Grid   .

        #region .   Raise Error   .
        public void RaiseError(string Message)
        {
            this.errorProvider1.Clear();
        }
        #endregion

        #endregion

        #region .   IEditType Members   .
        Type IEditType.EditType
        {
            get
            {
                return typeof(int);
            }
        }
        #endregion

        #region . Ultra Currency Editor Before Enter Edit Mode   .
        private void ultraCurrencyEditor1_BeforeEnterEditMode(object sender, CancelEventArgs e)
        {
            e.Cancel = true;
        }
        #endregion
    }
}