using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using Infragistics.Shared;
using Infragistics.Win;
using Infragistics.Win.UltraWinMaskedEdit;
using Infragistics.Win.UltraWinEditors;

namespace Shared.BaseClasses
{
    [Designer(typeof(DateBaseDesigner))]
    public partial class DateBase : UserControl
    {
        #region .   Variables   .

        #region .   BackColor   .
        [Description("The primary color used to fill the background."), Category("Appearance")]
        public Color BackColorDateTimeEditor
        {
            get { return this.ultraDateTimeEditor1.Appearance.BackColor; }
            set { this.ultraDateTimeEditor1.Appearance.BackColor = value; }
        }
        #endregion

        #region .   BackColor Disabled   .
        [Description("The primary color used to fill the background of disabled elements."), Category("Appearance")]
        public Color BackColorDisabledDateTimeEditor
        {
            get { return this.ultraDateTimeEditor1.Appearance.BackColorDisabled; }
            set { this.ultraDateTimeEditor1.Appearance.BackColorDisabled = value; }
        }
        #endregion

        #region .   DropDown Button Display Style   .
        [Description("Gets/sets the display style for the dropdown button."), Category("Appearance")]
        public ButtonDisplayStyle DropDownButtonDisplayStyle
        {
            get { return this.ultraDateTimeEditor1.DropDownButtonDisplayStyle; }
            set { this.ultraDateTimeEditor1.DropDownButtonDisplayStyle = value; }
        }
        #endregion

        #region .   DropDown Button Alignment   .
        [Description("Gets/sets the alignment for the controls dropdown button."), Category("Appearance")]
        public ButtonAlignment DropDownButtonAlignment
        {
            get { return this.ultraDateTimeEditor1.DropDownButtonAlignment; }
            set { this.ultraDateTimeEditor1.DropDownButtonAlignment = value; }
        }
        #endregion

        #region .   DropDown Calendar Alignment   .
        [Description("Gets/sets the alignment for the controls dropdown calendar."), Category("Appearance")]
        public DropDownListAlignment DropDownCalendarAlignment
        {
            get { return this.ultraDateTimeEditor1.DropDownCalendarAlignment; }
            set { this.ultraDateTimeEditor1.DropDownCalendarAlignment = value; }
        }
        #endregion

        #region .   Spin Button Display Style   .
        [Description("Gets/sets the display style for the controls spin buttons."), Category("Appearance")]
        public ButtonDisplayStyle SpinButtonDisplayStyle
        {
            get { return this.ultraDateTimeEditor1.SpinButtonDisplayStyle; }
            set { this.ultraDateTimeEditor1.SpinButtonDisplayStyle = value; }
        }
        #endregion

        #region .   Spin Button Alignment   .
        [Description("Gets/sets the alignment for the controls spin buttons."), Category("Appearance")]
        public ButtonAlignment SpinButtonAlignment
        {
            get { return this.ultraDateTimeEditor1.SpinButtonAlignment; }
            set { this.ultraDateTimeEditor1.SpinButtonAlignment = value; }
        }
        #endregion

        #region .   Format String   .
        [Description("Gets/sets the format string used by the control."), Category("Behavior")]
        public string FormatString
        {
            get { return this.ultraDateTimeEditor1.FormatString; }
            set { this.ultraDateTimeEditor1.FormatString = value; }
        }
        #endregion

        #region .   Min Date   .
        [Description("Gets/sets minimum date that will be accepted by the control."), Category("Behavior")]
        public DateTime MinDate
        {
            get { return this.ultraDateTimeEditor1.MinDate; }
            set { this.ultraDateTimeEditor1.MinDate = value; }
        }
        #endregion

        #region .   Max Date   .
        [Description("Gets/sets the maximum date that will be accepted by the control"), Category("Behavior")]
        public DateTime MaxDate
        {
            get { return this.ultraDateTimeEditor1.MaxDate; }
            set { this.ultraDateTimeEditor1.MaxDate = value; }
        }
        #endregion

        #region .   Mask Input   .
        [Description("Gets/sets the input mask that is used by the control."), Category("Behavior")]
        public string MaskInput
        {
            get { return this.ultraDateTimeEditor1.MaskInput; }
            set { this.ultraDateTimeEditor1.MaskInput = value; }
        }
        #endregion

        #region .   Mask Clip Mode   .
        [Description("Gets/sets the mask that is applied to the controls text when it is copied to the clipboard."), Category("Behavior")]
        public MaskMode MaskClipMode
        {
            get { return this.ultraDateTimeEditor1.MaskClipMode; }
            set { this.ultraDateTimeEditor1.MaskClipMode = value; }
        }
        #endregion

        #region .   Mask Display Mode   .
        [Description("Gets/sets the mask that is applied to the text displayed by the control when the control does not have input focus."), Category("Behavior")]
        public MaskMode MaskDisplayMode
        {
            get { return this.ultraDateTimeEditor1.MaskDisplayMode; }
            set { this.ultraDateTimeEditor1.MaskDisplayMode = value; }
        }
        #endregion

        #region .   Spin Increment   .
        [Description("Gets/sets a value to be used to increment/decrement the controls value when the controls spin buttons are used."), Category("Behavior")]
        public DateTimeIncrement SpinIncrement
        {
            get { return this.ultraDateTimeEditor1.SpinIncrement; }
            set { this.ultraDateTimeEditor1.SpinIncrement = value; }
        }
        #endregion

        #region .   Spin Wrap   .
        [Description("Gets/sets a value indicating whether the controls spin buttons should wrap its value."), Category("Behavior")]
        public bool SpinWrap
        {
            get { return this.ultraDateTimeEditor1.SpinWrap; }
            set { this.ultraDateTimeEditor1.SpinWrap = value; }
        }
        #endregion

        #region .   Prompt Character   .
        [Description("Character used for prompts."), Category("Misc")]
        public char PromptChar
        {
            get { return this.ultraDateTimeEditor1.PromptChar; }
            set { this.ultraDateTimeEditor1.PromptChar = value; }
        }
        #endregion

        #region .   Tab Navigation   .
        [Description(""), Category("Misc")]
        public MaskedEditTabNavigation TabNavigation
        {
            get { return this.ultraDateTimeEditor1.TabNavigation; }
            set { this.ultraDateTimeEditor1.TabNavigation = value; }
        }
        #endregion

        #region .   Enabled   .
        [Description("Indicates whether the control is enabled."), Category("Behavior")]
        public bool EnabledDateTimeEditor
        {
            get { return this.ultraDateTimeEditor1.Enabled; }
            set { this.ultraDateTimeEditor1.Enabled = value; }
        }
        #endregion

        #region .   Tab Index   .
        [Description("Determines the index in the TAB order that this control will occupy."), Category("Behavior")]
        public int TabIndexDateTimeEditor
        {
            get { return this.ultraDateTimeEditor1.TabIndex; }
            set { this.ultraDateTimeEditor1.TabIndex = value; }
        }
        #endregion

        #region .   Tab Stop   .
        [Description("Indicates wheter the user can use the TAB key to give focus to the control."), Category("Behavior")]
        public bool TabStopDateTimeEditor
        {
            get { return this.ultraDateTimeEditor1.TabStop; }
            set { this.ultraDateTimeEditor1.TabStop = value; }
        }
        #endregion

        #endregion

        #region .   Date Base   .
        public DateBase()
        {
            InitializeComponent();
        }

        #region .   Resize   .
        private void DateBase_Resize(object sender, EventArgs e)
        {
            this.ultraDateTimeEditor1.Size = ((Control)sender).Size;
        }
        #endregion

        #endregion

        #region .   Prompt Control Members   .

        #region .   Get Values   .
        public string[] GetValues()
        {
            return (new string[] { this.ultraDateTimeEditor1.Value.ToString()});
        }
        #endregion

        #region .   Get Value   .
        public string GetValue()
        {
            return (this.ultraDateTimeEditor1.Value.ToString());
        }
        #endregion

        #region .   Get Grid   .
        public ArrayList GetGrid()
        {
            return null;
        }
        #endregion .   Get Grid   .

        #region .   Raise Error   .
        public void RaiseError(string Message)
        {
            if (!this.ultraDateTimeEditor1.IsDateValid)
            {
                this.errorProvider1.SetError(this.ultraDateTimeEditor1, "");
                this.errorProvider1.SetError(this.ultraDateTimeEditor1, Message.ToUpper());
            }
            else
            {
                this.errorProvider1.Clear();
            }
        }
        #endregion

        #endregion

        #region .   Ultra Date Time Key Down   .
        private void ultraDateTimeEditor1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.A && e.Modifiers == Keys.Control && this.ultraDateTimeEditor1.ToString() != "")
            {
                e.Handled = true;
                this.ultraDateTimeEditor1.SelectAll();
            }
        }
        #endregion

        #region .   Ultra Date Time Before Enter Edit Mode   .
        private void ultraDateTimeEditor1_BeforeEnterEditMode(object sender, CancelEventArgs e)
        {
            e.Cancel = true;
        }
        #endregion
    }
}